import
  std/tables, ../utils

type
  MapEntityInfo* = tuple[center, delta: DFPoint, size: DFSize, width: int, texture: string]

const
  areaSpawnCenter*: DFPoint = (15, 12)
  areaFlagCenter*: DFPoint = (15, 11)
  areaSize*: DFSize = (34, 52)
  mapEntInfo*: Table[string, MapEntityInfo] = {
    # items
    "ITEM_MEDKIT_SMALL":          (center: (0, 0), delta: (0, 0), size: (14, 15), width:  0, texture: "game.wad:TEXTURES/MED1"),
    "ITEM_MEDKIT_LARGE":          (center: (0, 0), delta: (0, 0), size: (28, 19), width:  0, texture: "game.wad:TEXTURES/MED2"),
    "ITEM_MEDKIT_BLACK":          (center: (0, 0), delta: (0, 0), size: (28, 19), width:  0, texture: "game.wad:TEXTURES/BMED"),
    "ITEM_ARMOR_GREEN":           (center: (0, 0), delta: (0, 0), size: (31, 16), width: 32, texture: "game.wad:TEXTURES/ARMORGREEN"),
    "ITEM_ARMOR_BLUE":            (center: (0, 0), delta: (0, 0), size: (31, 16), width: 32, texture: "game.wad:TEXTURES/ARMORBLUE"),
    "ITEM_SPHERE_BLUE":           (center: (0, 0), delta: (0, 0), size: (25, 25), width: 32, texture: "game.wad:TEXTURES/SBLUE"),
    "ITEM_SPHERE_WHITE":          (center: (0, 0), delta: (0, 0), size: (25, 25), width: 32, texture: "game.wad:TEXTURES/SWHITE"),
    "ITEM_SUIT":                  (center: (0, 0), delta: (0, 0), size: (24, 47), width:  0, texture: "game.wad:TEXTURES/SUIT"),
    "ITEM_OXYGEN":                (center: (0, 0), delta: (0, 0), size: (14, 27), width:  0, texture: "game.wad:TEXTURES/OXYGEN"),
    "ITEM_INVUL":                 (center: (0, 0), delta: (0, 0), size: (25, 25), width: 32, texture: "game.wad:TEXTURES/INVUL"),
    "ITEM_WEAPON_SAW":            (center: (0, 0), delta: (0, 0), size: (62, 24), width:  0, texture: "game.wad:TEXTURES/SAW"),
    "ITEM_WEAPON_SHOTGUN1":       (center: (0, 0), delta: (0, 0), size: (63, 12), width:  0, texture: "game.wad:TEXTURES/SHOTGUN1"),
    "ITEM_WEAPON_SHOTGUN2":       (center: (0, 0), delta: (0, 0), size: (54, 13), width:  0, texture: "game.wad:TEXTURES/SHOTGUN2"),
    "ITEM_WEAPON_CHAINGUN":       (center: (0, 0), delta: (0, 0), size: (54, 16), width:  0, texture: "game.wad:TEXTURES/MGUN"),
    "ITEM_WEAPON_ROCKETLAUNCHER": (center: (0, 0), delta: (0, 0), size: (62, 16), width:  0, texture: "game.wad:TEXTURES/RLAUNCHER"),
    "ITEM_WEAPON_PLASMA":         (center: (0, 0), delta: (0, 0), size: (54, 16), width:  0, texture: "game.wad:TEXTURES/PGUN"),
    "ITEM_WEAPON_BFG":            (center: (0, 0), delta: (0, 0), size: (61, 36), width:  0, texture: "game.wad:TEXTURES/BFG"),
    "ITEM_WEAPON_SUPERPULEMET":   (center: (0, 0), delta: (0, 0), size: (54, 16), width:  0, texture: "game.wad:TEXTURES/SPULEMET"),
    "ITEM_AMMO_BULLETS":          (center: (0, 0), delta: (0, 0), size: ( 9, 11), width:  0, texture: "game.wad:TEXTURES/CLIP"),
    "ITEM_AMMO_BULLETS_BOX":      (center: (0, 0), delta: (0, 0), size: (28, 16), width:  0, texture: "game.wad:TEXTURES/AMMO"),
    "ITEM_AMMO_SHELLS":           (center: (0, 0), delta: (0, 0), size: (15,  7), width:  0, texture: "game.wad:TEXTURES/SHELL1"),
    "ITEM_AMMO_SHELLS_BOX":       (center: (0, 0), delta: (0, 0), size: (32, 12), width:  0, texture: "game.wad:TEXTURES/SHELL2"),
    "ITEM_AMMO_ROCKET":           (center: (0, 0), delta: (0, 0), size: (12, 27), width:  0, texture: "game.wad:TEXTURES/ROCKET"),
    "ITEM_AMMO_ROCKET_BOX":       (center: (0, 0), delta: (0, 0), size: (54, 21), width:  0, texture: "game.wad:TEXTURES/ROCKETS"),
    "ITEM_AMMO_CELL":             (center: (0, 0), delta: (0, 0), size: (15, 12), width:  0, texture: "game.wad:TEXTURES/CELL"),
    "ITEM_AMMO_CELL_BIG":         (center: (0, 0), delta: (0, 0), size: (32, 21), width:  0, texture: "game.wad:TEXTURES/CELL2"),
    "ITEM_AMMO_BACKPACK":         (center: (0, 0), delta: (0, 0), size: (22, 29), width:  0, texture: "game.wad:TEXTURES/BPACK"),
    "ITEM_KEY_RED":               (center: (0, 0), delta: (0, 0), size: (16, 16), width:  0, texture: "game.wad:TEXTURES/KEYR"),
    "ITEM_KEY_GREEN":             (center: (0, 0), delta: (0, 0), size: (16, 16), width:  0, texture: "game.wad:TEXTURES/KEYG"),
    "ITEM_KEY_BLUE":              (center: (0, 0), delta: (0, 0), size: (16, 16), width:  0, texture: "game.wad:TEXTURES/KEYB"),
    "ITEM_WEAPON_KASTET":         (center: (0, 0), delta: (0, 0), size: ( 1,  1), width:  0, texture: "game.wad:TEXTURES/KASTET"),
    "ITEM_WEAPON_PISTOL":         (center: (0, 0), delta: (0, 0), size: (43, 16), width:  0, texture: "game.wad:TEXTURES/PISTOL"),
    "ITEM_BOTTLE":                (center: (0, 0), delta: (0, 0), size: (14, 18), width: 16, texture: "game.wad:TEXTURES/BOTTLE"),
    "ITEM_HELMET":                (center: (0, 0), delta: (0, 0), size: (16, 15), width: 16, texture: "game.wad:TEXTURES/HELMET"),
    "ITEM_JETPACK":               (center: (0, 0), delta: (0, 0), size: (32, 24), width:  0, texture: "game.wad:TEXTURES/JETPACK"),
    "ITEM_INVIS":                 (center: (0, 0), delta: (0, 0), size: (25, 25), width: 32, texture: "game.wad:TEXTURES/INVIS"),
    "ITEM_WEAPON_FLAMETHROWER":   (center: (0, 0), delta: (0, 0), size: (53, 20), width:  0, texture: "game.wad:TEXTURES/FLAMETHROWER"),
    "ITEM_AMMO_FUELCAN":          (center: (0, 0), delta: (0, 0), size: (13, 20), width:  0, texture: "game.wad:TEXTURES/FUELCAN"),
    # areas
    "AREA_PLAYERPOINT1":          (center: areaSpawnCenter, delta: (0, 0), size: areaSize, width: 0, texture: "editor.wad:TEXTURES/P1POINT"),
    "AREA_PLAYERPOINT2":          (center: areaSpawnCenter, delta: (0, 0), size: areaSize, width: 0, texture: "editor.wad:TEXTURES/P2POINT"),
    "AREA_DMPOINT":               (center: areaSpawnCenter, delta: (0, 0), size: areaSize, width: 0, texture: "editor.wad:TEXTURES/DMPOINT"),
    "AREA_REDFLAG":               (center: areaFlagCenter,  delta: (0, 0), size: areaSize, width: 0, texture: "game.wad:TEXTURES/FLAGRED"),
    "AREA_BLUEFLAG":              (center: areaFlagCenter,  delta: (0, 0), size: areaSize, width: 0, texture: "game.wad:TEXTURES/FLAGBLUE"),
    "AREA_DOMFLAG":               (center: areaFlagCenter,  delta: (0, 0), size: areaSize, width: 0, texture: "game.wad:TEXTURES/FLAGDOM"),
    "AREA_REDTEAMPOINT":          (center: areaSpawnCenter, delta: (0, 0), size: areaSize, width: 0, texture: "editor.wad:TEXTURES/REDPOINT"),
    "AREA_BLUETEAMPOINT":         (center: areaSpawnCenter, delta: (0, 0), size: areaSize, width: 0, texture: "editor.wad:TEXTURES/BLUEPOINT"),
    # monsters
    "MONSTER_DEMON":              (center: ( 7,  8), delta: (  1,   4), size: ( 50,  52), width:  64, texture: "game.wad:MTEXTURES/DEMON_SLEEP"),
    "MONSTER_IMP":                (center: (15, 10), delta: (  8,  -4), size: ( 34,  50), width:  64, texture: "game.wad:MTEXTURES/IMP_SLEEP"),
    "MONSTER_ZOMBIE":             (center: (15,  8), delta: (  1,  -4), size: ( 34,  52), width:  64, texture: "game.wad:MTEXTURES/ZOMBY_SLEEP"),
    "MONSTER_SERG":               (center: (15,  8), delta: (  1,  -4), size: ( 34,  52), width:  64, texture: "game.wad:MTEXTURES/SERG_SLEEP"),
    "MONSTER_CYBER":              (center: (24,  9), delta: (  2,  -6), size: ( 80, 110), width: 128, texture: "game.wad:MTEXTURES/CYBER_SLEEP"),
    "MONSTER_CGUN":               (center: (15,  4), delta: ( -1,  -2), size: ( 34,  56), width:  64, texture: "game.wad:MTEXTURES/CGUN_SLEEP"),
    "MONSTER_BARON":              (center: (39, 32), delta: (  4,   0), size: ( 50,  64), width: 128, texture: "game.wad:MTEXTURES/BARON_SLEEP"),
    "MONSTER_KNIGHT":             (center: (39, 32), delta: (  4,   0), size: ( 50,  64), width: 128, texture: "game.wad:MTEXTURES/KNIGHT_SLEEP"),
    "MONSTER_CACO":               (center: (34, 36), delta: (  0,  -4), size: ( 60,  56), width: 128, texture: "game.wad:MTEXTURES/CACO_SLEEP"),
    "MONSTER_SOUL":               (center: (16, 14), delta: (  1, -10), size: ( 32,  36), width:  64, texture: "game.wad:MTEXTURES/SOUL_SLEEP"),
    "MONSTER_PAIN":               (center: (34, 36), delta: (  0,  -4), size: ( 60,  56), width: 128, texture: "game.wad:MTEXTURES/PAIN_SLEEP"),
    "MONSTER_SPIDER":             (center: (23, 14), delta: ( -4,  -4), size: (210, 100), width: 256, texture: "game.wad:MTEXTURES/SPIDER_SLEEP"),
    "MONSTER_BSP":                (center: (14, 17), delta: (  0,  -1), size: (100,  42), width: 128, texture: "game.wad:MTEXTURES/BSP_SLEEP"),
    "MONSTER_MANCUB":             (center: (28, 34), delta: ( -2,  -7), size: ( 72,  60), width: 128, texture: "game.wad:MTEXTURES/MANCUB_SLEEP"),
    "MONSTER_SKEL":               (center: (30, 28), delta: ( -1,   4), size: ( 68,  72), width: 128, texture: "game.wad:MTEXTURES/SKEL_SLEEP"),
    "MONSTER_VILE":               (center: (30, 28), delta: (  5, -21), size: ( 68,  72), width: 128, texture: "game.wad:MTEXTURES/VILE_SLEEP"),
    "MONSTER_FISH":               (center: ( 6, 11), delta: ( -1,   0), size: ( 20,  10), width:  32, texture: "game.wad:MTEXTURES/FISH_SLEEP"),
    "MONSTER_BARREL":             (center: (20, 13), delta: (  0, -15), size: ( 24,  36), width:  64, texture: "game.wad:MTEXTURES/BARREL_SLEEP"),
    "MONSTER_ROBO":               (center: (30, 26), delta: ( -2, -26), size: ( 68,  76), width: 128, texture: "game.wad:MTEXTURES/ROBO_SLEEP"),
    "MONSTER_MAN":                (center: (15,  6), delta: (  0,  -6), size: ( 34,  52), width:  64, texture: "game.wad:MTEXTURES/MAN_SLEEP"),
  }.toTable()
